/**
 * 
 */
package net.bigeon.gclc.swt;

import java.io.BufferedReader;

import org.eclipse.swt.widgets.Label;

/** @author Emmanuel Bigeon */
public final class ConsolePromptManager {

    private final Label       label;

    private PromptReadingRunnable promptRead;

    /** @param label the label to update */
    public ConsolePromptManager(final Label label) {
        super();
        this.label = label;
    }

    /** @param string the text */
    public void setPrompt(final String string) {
        label.setText(string);
    }

    /** Set the input to control
     * 
     * @param promptStream the input */
    public void setStream(final BufferedReader promptStream) {
        if (promptRead != null) {
            if (promptRead.getReader() == promptStream) {
                return;
            }
            promptRead.setRunning(false);
        }
        if (promptStream == null) {
            promptRead = null;
            return;
        }
        promptRead = new PromptReadingRunnable(promptStream,
                label);
        final Thread th = new Thread(promptRead, "Prompt To Label");
        th.start();
    }
}
