/**
 * 
 */
package net.bigeon.gclc.test;

import static org.junit.Assert.assertFalse;
import static org.junit.Assert.assertTrue;
import static org.junit.Assert.fail;

import java.io.IOException;
import java.util.function.Supplier;

import net.bigeon.gclc.manager.ConsoleInput;

/**
 * @author Emmanuel Bigeon
 *
 */
public final class InputContract {

    public void testInputContract(final Supplier<ConsoleInput> inputs)
            throws IOException {
        // Test close contract
        final ConsoleInput input = inputs.get();
        assertFalse("An input should not initially be closed", input.isClosed());
        input.close();
        assertTrue("An input should close", input.isClosed());
        input.close();
        assertTrue("A closed input should stay closed", input.isClosed());
        try {
            input.prompt();
            fail("Closed input prompting should fail");
        } catch (final IOException e) {
            // ok
        }
    }
}
