/**
 * 
 */
package net.bigeon.gclc.system;

import static org.junit.Assert.assertTrue;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;

import org.junit.Test;
import org.mockito.Mockito;

import net.bigeon.gclc.exception.CommandRunException;
import net.bigeon.gclc.utils.SinkOutput;
import net.bigeon.gclc.utils.StreamConsoleOutput;

/** @author Emmanuel Bigeon */
public class ForwardingRunnableTest {

    public void testClosedOutput() {
        final StreamConsoleOutput out = new StreamConsoleOutput();
        out.close();
        final InputStream is = new ByteArrayInputStream(new byte[] { 1, 2, 3 });
        final ForwardingRunnable runnable = new ForwardingRunnable(out, is);
        // Runnable should close immediatly.
        runnable.run();

        assertTrue("Error should be a CommandRunException",
                runnable.getError() instanceof CommandRunException);
    }

    @Test
    public void testIOInInput() throws IOException {
        final InputStream is = Mockito.mock(InputStream.class);
        Mockito.when(is.read()).thenThrow(new IOException());
        final ForwardingRunnable runnable = new ForwardingRunnable(SinkOutput.INSTANCE,
                is);
        // Runnable should close immediatly.
        runnable.run();
        assertTrue("Error should be an IO", runnable.getError() instanceof IOException);
    }
}
